unit uCopyIf;

interface

Uses Settings;

Procedure RunCopyIfMode;
Procedure DefCounter (Const Bez: String; Const Sep: Boolean);
Procedure IncCounter (Const Bez, SubBez: String);
Procedure Grouplist_add(Const Gruppen: String);
Procedure Grouplist_set(Const Gruppen: String);

Var CopyIf_Opt: TCIEinstellungen = NIL;

implementation

Uses Windows, classes, sysutils, inifiles, uHamster,
     uArtikel, uHeader, uKnSkr, Korrektu;

Var slMids: TStringlist;
    ZPostings, ZGroups: LongInt;
    ZExported, ZSaved, ZCopies, Start: Longint;
    bHamsterAddLog : boolean;
    Grouplist: String;
    Grouplist_changed: boolean;

Procedure CheckPosting (Posting: TStrings; AktOpt: TCIEinstellungen);

   Procedure DoSave;
   //Var s: String;
   begin
      {s := ChangeFileExt(fn,'.bak');
      If FileExists(s) then DeleteFile(s);
      If Opt.ConvertToExt > '' then begin
         NeuerDateiname :=  ChangeFileExt(fn, '.'+Opt.ConvertToExt);
         Save ( NeuerDateiname )
      end else begin
         If Opt.MakeBAK then RenameFile (fn, s);
         Save (fn)
      end}
   end;

   Procedure DoCopyOld;
   begin
      // Nothing to do...
   end;

   Procedure DoDelete;
   begin
{      DeleteFile(fn);
      NeuerDateiname := '' }
   end;

Var Artikel: TArtikel;
    Skript: TKnSkript;
    Opt: TKnEinstellungen;
    bChanged: boolean;
begin
   If Posting.text > '' then begin
      Artikel := TArtikel.Create (Extra.InternalCharset, Extra.DefHeaderCharsets, Extra.DefBodyCharsets);
      try
         With Artikel do begin
            ConvertToSigTrenner := '--';
            SafeReg1 := 0;
            SafeReg2 := 0;
            Gesamttext := Posting.text;
            Grouplist_changed := false;
            Grouplist := Header.Inhalt('Newsgroups', hiRaw);
         end;
         Opt := TKnEinstellungen.Create;
         Opt.AutoFunctions := false;
         Skript := TKNSkript.Create('', Opt, Artikel);
         try
            bChanged := Check(Skript, Opt, Artikel);
            Case Artikel.EndAction of
               eaSaveChanges: if bChanged then DoSave;
               eaCancelChanges: if Opt.ConvertToExt>'' then DoCopyOld;
               eaDelete: If Opt.ConvertToExt = '' then DoDelete;
               eaSaveAndSigHeaders: DoSave;
            end
         finally
            Skript.free;
            Opt.free
         end
      finally
         Artikel.free
      end
   end
end;

Procedure Grouplist_add(Const Gruppen: String);
Var s, s2: String; p: Integer;
begin
   s := Gruppen;
   repeat
      p := Pos(',', s);
      If p > 0 then begin s2 := Copy(s, 1, p-1); Delete(s, 1, p) end
               else begin s2 := s; s := '' end;
      s2 := Trim(s2);
      If s2 > '' then begin
         if Pos(','+LowerCase(s2)+',', ','+LowerCase(Grouplist)+',')=0 then begin
            Grouplist_changed := true;
            If Grouplist > '' then Grouplist := Grouplist + ',';
            Grouplist := Grouplist + s2
         end
      end
   Until s = ''
end;

Procedure Grouplist_set(Const Gruppen: String);
begin
   Grouplist := '';
   Grouplist_changed := true;
   Grouplist_add (Gruppen)
end;

Function Enter (Ini: TInifile): Boolean;
begin
   ZGroups := 0; ZPostings := 0;
   ZExported := 0; ZSaved := 0; ZCopies := 0;
   Start := GetTickCount;
   Result := true
end;

Function Enter2: boolean;
begin
   CopyIf_Opt := TCIEinstellungen.Create;
   With CopyIf_Opt do begin
      Abschnitt := 'Settings';
      ReadSettings (false);
      lCounter.Clear;
   end;
   Result := true
end;

Function DoIt: boolean;
Var ArtNr, Last: Integer; b: Boolean;
begin
   If Gruppe_erlaubt(AktGruppeBez,
      CopyIf_Opt.lIgnoreGroups,
      CopyIf_Opt.lDontIgnoreGroups)
   then begin
      OeffneGruppe;
      Inc(ZGroups);
      If bHamsterAddLog then try
         Hamster.ControlAddLog ( 'CopyIf: '+AktGruppebez + ' wird getestet', 3)
      except bHamsterAddLog := false end;

      Last := Ini.ReadInteger ('Groups', AktGruppeBez, 0);
      With CopyIf_Opt do begin
         If (Last = 0) and (NewGroups_TestMax > 0) then
            If NewGroups_TestMax < MaxArtikel-Last
               then Last := MaxArtikel - NewGroups_TestMax;
         If Last < MinArtikel-1 then Last := MinArtikel-1;
         If TestMaxPostings > 0 then
            If TestMaxPostings < MaxArtikel-Last
               then Last := MaxArtikel - TestMaxPostings
      end;

      { Alle neuen Artikel durchgehen }
      For ArtNr := Last + 1 to MaxArtikel do begin
         If bHamsterAddLog then begin
            Hamster.ControlAddLog ( 'CopyIf: '+AktGruppebez + ' wird getestet - '
                    +IntToStr(Trunc((ArtNr-Last)*100.0/(MaxArtikel-Last)))+'%', 7)
         end;
         LadeArtikel (ArtNr); Inc(ZPostings);
         If CopyIf_Opt.Simulate or (Posting.IndexOf(HeaderCopyIf) < 0) then begin
            b := true;
            If CopyIf_Opt.CheckXPostingsOnlyOnce then begin
               b := slMIDs.IndexOf (MID) < 0;
               If Not b then slMIDs.Add (MID)
            end;
            If b then CheckPosting (Posting, CopyIf_Opt)
         end
      end;

      If Not CopyIf_Opt.Simulate then Ini.WriteInteger ('Groups', AktGruppeBez, MaxArtikel);
   end;
   Result := true
end;

Procedure ShowResult (Const Ver: String; Const Gruppen, Postings, Exported, Copied, Changed: LongInt;
            Const lCounter: TStrings);
Var Dauer: Longint; s: String; Gesamt: String;

   Function MSekToTimeStr (Const Dauer: LongInt): String;
   Var D, F, X: LongInt; s: String;
   begin
      D := Dauer; F := 1000*60*60;
      X := D Div F; D := D - X*F; F := F div 60;
      Result := Inttostr(X);
      X := D Div F; D := D - X*F; F := F div 60;
      s := Inttostr(X); If Length(s)<2 then s := '0'+s;
      Result := Result + '.' + s;
      X := D Div F; D := D - X*F;
      s := Inttostr(X); If Length(s)<2 then s := '0'+s;
      Result := Result + '.' + s;
      X := D;
      s := Inttostr(X); While Length(s)<3 do s := '0'+s;
      Result := Result + ':' + s
   end;

begin
   Dauer := GetTickCount - Start;
   Gesamt := '';
   If lCounter.Count > 0 then begin
      Gesamt := Gesamt + lCounter.text + #13#10
   end;
   Gesamt := Gesamt
      +  'STATISTIK'
      +#13#10;
   Gesamt := Gesamt
      +  'Gruppen: '+Inttostr(Gruppen)
      + ', Artikel: '+Inttostr(Postings)
      + ', Exportiert: '+Inttostr(Exported)
      + ', Kopiert: '+Inttostr(Copied)
      + ', Gendert: '+Inttostr(Changed)
      +#13#10;
   If Dauer > 0 then s := MSekToTimeStr(Dauer)
                else s := '-';
   Gesamt := Gesamt
      +  'Gesamtdauer: '+s;
   If (Dauer > 0) and (Postings > 0)
      then s := MSekToTimeStr(Dauer div Postings)
      else s := '-';
   Gesamt := Gesamt
      +  ', Je Posting: '+s
      +#13#10;
   MessageBox (0, PChar(Gesamt), PChar('Korrnews/CopyIf V'+Ver+' - Ergebnisse'), MB_OK)
end;

Function Leave: boolean;
Var Counted, p, i: Integer; r, r2: TSearchRec; b: boolean; s, Aktion: String;
begin
   try
      Aktion := 'Setze Application.Title';
      // With Application do Title := 'Fertig!';
      { ggf. Mails zhlen }
      Aktion := 'MailInfo';
      If CopyIf_Opt.MailInfo then begin
         b := false;
         try
            s := Hamster.ControlGetMailsPath
         except
            s := Hamster.ControlGetPath+'Mails\'
         end;
         If FindFirst(s+'*.*', faDirectory, r)=0 then begin
            Repeat
               If (Lowercase(r.Name) <> 'mail.out') and (r.Name[1]<>'.') then begin
                  i := 0;
                  If FindFirst(s+r.Name+'\*.msg', faArchive, r2)=0 then begin
                     Repeat Inc(i) Until FindNext(r2)<>0;
                     FindClose(r2);
                     If Not b then begin
                        b := true; CopyIf_Opt.lCounter.Add ('')
                     end;
                     CopyIf_Opt.lCounter.AddObject ('Unabgeholte Mails fr "'+r.name+'"', Pointer(i))
                  end
               end
            Until FindNext(r)<>0;
            FindClose(r)
         end
      end;
      { ggf. Endausgabe }
      Aktion := 'Countercheck';
      With CopyIf_Opt.lCounter do begin
         Aktion := 'Countercheck: 0er lschen';
         If CopyIf_Opt.ShowOnlyCounterGreaterThanNull
            then For i:=Count-1 downto 0 do If (Strings[i]>'') and (LongInt(Objects[i])=0) then Delete(i);
         Counted := 0;
         Aktion := 'Countercheck: Addiere Counted';
         For i:=0 to Count-1 do If (Strings[i]>'') then Counted := Counted + LongInt(Objects[i]);
         Aktion := 'Countercheck: Doppelleerzeilen lschen';
         For i:=Count-2 downto 0 do If (Strings[i]='') and (Strings[i+1]='') then Delete(i);
         Aktion := 'Countercheck: Leerzeilen oben lschen';
         While (Count > 0) and (Strings[0]='') do Delete(0);
         Aktion := 'Countercheck: Leerzeilen unten lschen';
         While (Count > 0) and (Strings[Count-1]='') do Delete(Count-1);
         Aktion := 'Countercheck: * extrahieren';
         If Count > 0 then begin
            For i := 0 to Count-1 do
               if Strings[i]>'' then begin
                  P := Pos('*', Strings[i]);
                  If P=0 then Strings[i] := Strings[i] + ': ' + IntToStr(LongInt(Objects[i]))
                         else Strings[i] := Copy(Strings[i], 1, p-1) + IntToStr(LongInt(Objects[i]))
                                            + Copy(Strings[i], p+1, Length(Strings[i])-p)
               end;
            {MessageDlg (Copy(Text, 1, Length(Text)-2), mtInformation, [mbOk], 0)}
         end
      end;
      Aktion := 'Result anzeigen';
      With CopyIf_Opt do begin
         if ShowResultAlways or (ShowResultIfAction and (ZExported+ZCopies+ZSaved > 0))
            or (ShowResultIfCounter and (Counted>0))
         then
            ShowResult (Ver, ZGroups, ZPostings, ZExported, ZCopies, ZSaved, lCounter)
         end
   except
      On E:Exception do begin
         ShowMessage ('Fehler "'+E.message+'" ('+E.classname+')');
         raise
      end
   end;
   Result := true
end;

Procedure RunCopyIfMode;
Var s: String;
begin
   AktVer := Ver;
   bHamsterAddLog := true;
   With TCIEinstellungen.Create do try
      s := Dateiname;
   finally free end;
   If Not FileExists(s) then begin
      ShowMessage ('Keine CopyIf.def vorhanden => Abbruch');
      Halt
   end;
   try
      slMIDs := TStringlist.Create;
      slMIDs.sorted := true;
      try
         DoMain (s, Enter, Enter2, DoIt, Leave)
      except
         On EAbort do;
      end
   finally slMIDs.free end
end;

Procedure DefCounter (Const Bez: String; Const Sep: Boolean);
Var p: Integer;
begin
   If Not Assigned(CopyIf_Opt) then exit;
   With CopyIf_Opt.lCounter do begin
      If Sep then begin
         If (Count > 0) and (Strings[Count-1]>'') then Add ('')
      end else begin
         p := IndexOf(Bez);
         If p < 0 then Add(Bez)
      end
   end
end;

Procedure IncCounter (Const Bez, SubBez: String);
Var p, p2, i: Integer;
Const Einschub = ' - ';
begin
   If Not Assigned(CopyIf_Opt) then exit;
   With CopyIf_Opt.lCounter do begin
      p := IndexOf(Bez);
      If p<0 then p := Add(Bez);
      Objects[p] := Pointer(LongInt(Objects[p])+1);
      If SubBez > '' then begin
         p2 := 0;
         For i:=p+1 to Count-1 do begin
            if Copy(Strings[i], 1, Length(Einschub))<>Einschub
               then begin p := i-1; break end
               else If Strings[i] = Einschub+SubBez then p2 := i
         end;
         If p2 = 0 then begin p2 := p+1; Insert (p2, Einschub+SubBez) end;
         Objects[p2] := Pointer(LongInt(Objects[p2])+1)
      end
   end
end;

end.
