unit uHamster;

interface

Uses OleAuto, SysUtils, IniFiles, Windows, Classes;

Type TOKFunction = Function: boolean;
     TEnterFunction = Function (Ini: TIniFile): boolean;

Procedure DoMain (Enter: TEnterFunction; Enter2, DoIt, Leave: TOkFunction);
Function  Gruppe_erlaubt (Const Gr, V1, V2: String; lIgn, lDontIgn, lIgn2: TStrings): boolean;
Procedure OeffneGruppe;
Procedure LadeArtikel (Const Nr: Integer);

Procedure GetHamsterGruppenliste (sl: TStrings);

Function  PosBodyBegin: Integer;
Function  GetPos(Const Header: String; Var Anfang, Ende: Integer;
      Var NeuHeader: String): boolean;

Procedure SpeichereArtikelKopie (Const NewsGroups, AddToMessageID: String);

Const RefHeader = 'References: ';
      MessageIDHeader = 'Message-ID: ';
      CRLF = #13#10;

Var Hamster: Variant;
    Ini: TIniFile;
    AktGruppeHandle, MinArtikel, MaxArtikel,
    AnzGruppen, AktGruppeNr: LongInt;
    AktGruppeBez,
    AltText, NeuText: String;

implementation

{ ================= Sonderfunktionen ===================== }

Procedure GetHamsterGruppenliste (sl: TStrings);
Var Hamster: Variant; Gr: Integer;
begin
   sl.Clear;
   Hamster := CreateOleObject('Hamster.App');
   For Gr := 0 to Hamster.NewsGrpCount - 1 do sl.Add (Hamster.NewsGrpName(Gr));
   Hamster := Unassigned
end;

{ ========================================================= }

Var Gruppe_geoeffnet: boolean;
    ArtikelNr: Integer;

Function GetPos(Const Header: String; Var Anfang, Ende: Integer;
      Var NeuHeader: String): boolean;
begin
   Anfang := Pos(Header, AltText);
   Result := Anfang > 0;
   If Result then begin
      Ende := Anfang + Length(Header) - 1;
      Repeat
         Inc(Ende);
         While AltText[Ende+1]<>^m do Inc(Ende)
      Until (AltText[Ende+3]<>^i) and (AltText[Ende+3]<>' ');
      NeuHeader := Copy(AltText, Anfang + Length(Header),
         Ende - Anfang - Length(Header) + 1)
   end
end;

Function PosBodyBegin: Integer;
begin
   Result := Pos(CRLF+CRLF, AltText) + 2
end;

Procedure OeffneGruppe;
begin
   if not Gruppe_geoeffnet then begin
      AktGruppeHandle := Hamster.NewsGrpOpen(AktGruppeBez);
      MinArtikel := Hamster.NewsArtNoMin(AktGruppeHandle);
      MaxArtikel := Hamster.NewsArtNoMax(AktGruppeHandle);
      Gruppe_geoeffnet := true
   end else begin
      Messagebox (0, PChar('Interner Fehler: Versuch, eine Gruppe mehrfach zu ffnen!'),
                  PChar('Copy Followups V1.1 by Thomas G. Liesner'), 0);
      Halt
   end
end;

Procedure LadeArtikel (Const Nr: Integer);
begin
   if Gruppe_geoeffnet then begin
      AltText := Hamster.NewsArtText(AktGruppeHandle, Nr);
      ArtikelNr := Nr
   end else begin
      Messagebox (0, PChar('Interner Fehler: Gruppe ist nicht geffnet, aber "LadeArtikel" wurde aufgerufen!'),
                  PChar('Copy Followups V1.1 by Thomas G. Liesner'), 0);
      Halt
   end
end;

Procedure SpeichereArtikelKopie (Const NewsGroups, AddToMessageID: String);
Var Anfang, Ende: Integer; AktHeader: String;
begin
   If Not Gruppe_geoeffnet then begin
      Messagebox (0, PChar('Interner Fehler: Gruppe ist nicht geffnet, aber "SpeichereArtikelKopie" wurde aufgerufen!'),
                  PChar('Copy Followups V1.1 by Thomas G. Liesner'), 0);
      Halt
   end else
   If ArtikelNr < 0 then begin
      Messagebox (0, PChar('Interner Fehler: Kein Artikel geladen, aber "SpeichereArtikelKopie" wurde aufgerufen!'),
                  PChar('Copy Followups V1.1 by Thomas G. Liesner'), 0);
      Halt
   end else begin
      If AddToMessageID > '' then begin
         GetPos('X-'+MessageIDHeader, Anfang, Ende, AktHeader);
         If Anfang = 0 then begin
            GetPos(MessageIDHeader, Anfang, Ende, AktHeader);
            If Anfang > 1
               then NeuText := Copy(AltText, 1, Anfang-3) + Copy(AltText, Ende + 1, Length(AltText))
               else NeuText := Copy(AltText, Ende + 3, Length(AltText));
            NeuText := 'X-'+MessageIDHeader+AktHeader+CRLF
                       + MessageIDHeader+'<'+AddToMessageID+Copy(AktHeader,2,Length(AktHeader)-1)+CRLF
                       + NeuText
         end;
         {Messagebox(0,PChar(Neutext), NIL, 0);}
         Hamster.NewsImport(NeuText, NewsGroups, false, false)
      end else begin
         Hamster.NewsImport(AltText, NewsGroups, true, false)
      end
   end
end;

Procedure DoMain (Enter: TEnterFunction; Enter2, DoIt, Leave: TOkFunction);
Var Gr: LongInt;
begin
   Ini := TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini'));
   try
      If Enter(Ini) then try
         Hamster := CreateOleObject('Hamster.App');
         AnzGruppen := Hamster.NewsGrpCount;
         If Enter2 then begin
            For Gr := 0 to Hamster.NewsGrpCount - 1 do begin
               AktGruppeNr := Gr+1;
               AktGruppeBez := Hamster.NewsGrpName(Gr);
               Gruppe_geoeffnet := false; ArtikelNr := -1;
               If Not Doit then break;
               If Gruppe_geoeffnet then Hamster.NewsGrpClose(AktGruppeHandle);
            end;
            Leave
         end
      finally
         Hamster := Unassigned
      end
   finally
      Ini.free
   end;
end;

Function Gruppe_erlaubt (Const Gr, V1, V2: String; lIgn, lDontIgn, lIgn2: TStrings): boolean;
Var j: Integer;
begin
   Result := (Gr <> V1) and (Gr <> V2);
   If Result then begin
      { ... oder zu ignorierende Gruppen ... }
      If Assigned(lIgn) then
         For j := 0 to lIgn.Count-1 do
            If Result then Result := LowerCase(Copy(Gr, 1, Length(lIgn[j])))
                                  <> LowerCase(lIgn[j]);
      If (Not Result) and Assigned(lDontIgn) then begin
         { ... ausser es ist eine trotzdem zu beachtende Gruppe }
         For j := 0 to lDontIgn.Count-1 do
            If Not Result then Result := LowerCase(Copy(Gr, 1, Length(lDontIgn[j])))
                                       = LowerCase(lDontIgn[j])
      end;
      { ... sofern es sich natrlich um keine Mixgroups-Zielgruppe handelt }
      If Result and Assigned(lIgn2) then begin
         For j := 0 to lIgn2.Count-1 do
            If Result then Result := LowerCase(Copy(Gr, 1, Length(lIgn2[j])))
                                  <> LowerCase(lIgn2[j])
      end
   end
end;

end.
